"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.miniEspParser = void 0;
var LEDEnum;
(function (LEDEnum) {
    LEDEnum[LEDEnum["red"] = 1] = "red";
    LEDEnum[LEDEnum["green"] = 2] = "green";
    LEDEnum[LEDEnum["blue"] = 3] = "blue";
})(LEDEnum || (LEDEnum = {}));
let modelObj = {
    LEDon(color) {
        return `LED${LEDEnum[color]}.set();`;
    },
    LEDoff(color) {
        return `LED${LEDEnum[color]}.reset();`;
    },
    LEDtoggle(color) {
        return `LED${LEDEnum[color]}.toggle();`;
    },
    LEDflash(color, ms) {
        return `digitalPulse(LED${LEDEnum[color]},1,${ms});`;
    },
    LEDval(color) {
        return `digitalRead(LED${color}) == 1;`;
    },
    NFCsetUrl(url) {
        return `NRF.nfcURL(${url});`;
    },
    NFCreset() {
        return `NRF.nfcURL();`;
    },
    IRtransmit(data) {
        return `Puck.IR([${data.join(',')}]);`;
    },
    MagenableMag() {
        return `Puck.magOn();`;
    },
    MagenableField() {
        return `require("puckjsv2-mag-level").on();`;
    },
    MagdisableMag() {
        return `Puck.magOff();`;
    },
    MagdisableField() {
        return `require("puckjsv2-mag-level").off();`;
    },
    getLightVal() {
        return `Puck.light();`;
    },
    accelenableAccelMovement() {
        return `require("puckjsv2-accel-movement").on();`;
    },
    accelenableAccelBigMovement() {
        return `require("puckjsv2-accel-bigmovement").on();`;
    },
    accelenableAccelTilt() {
        return `require("puckjsv2-accel-tilt").on();`;
    },
    acceldisableAccelMovement() {
        return `require("puckjsv2-accel-movement").off();`;
    },
    acceldisableAccelBigMovement() {
        return `require("puckjsv2-accel-bigmovement").off();`;
    },
    acceldisableAccelTilt() {
        return `require("puckjsv2-accel-tilt").off();`;
    },
    accelval() {
        return `Puck.accel();`;
    },
    getTemperature() {
        return `E.getTemperature();`;
    },
    dump() {
        return `E.dumpStr();`;
    },
    getDeviceType() {
        return `process.env.BOARD`;
    },
};
function replaceCode(str) {
    let convertedObjName = str
        .split('(')[0]
        .split('.')
        .slice(1)
        .join('.')
        .replace(/\./g, '');
    let params = str.split('(')[1].replace(')', '').replace(/\'/g, '').split(',');
    return modelObj[convertedObjName](...params);
}
function miniEspParser(func) {
    let stringified_func = func.toString().split('\n').slice(1, -1).join('\n');
    // This will grab any method call from the code for use in replace
    let deviceObjMethodRegex = /[a-zA-Z]+.+[a-zA-Z]+.+[a-zA-Z]+[\((+([a-zA-Z\d.!?\\\"\'-\\\(\s\)]+\)|\)];/g;
    return stringified_func.replace(deviceObjMethodRegex, (e) => replaceCode(e));
}
exports.miniEspParser = miniEspParser;
let code = function () {
    Puck.LED.on('green');
};
